/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function CODE_Monitor		//<c><a>public<d>Code panel monitor class
(
_mediator,		//<p>GUI_Mediator<d>Application mediator instance
_editorId		//<p>string<d>Editor element ID
){
//================
this.CODE_Monitor = function		//<m>void<a>private<d>class constructor
(
mediator,		//<p>GUI_Mediator<d>Application mediator instance
editorId		//<p>string<d>Editor element ID
){
this.prototype = CONTENT_Monitor;
this.prototype(mediator, editorId, MZQ.K.CODE_LABEL);
this.className	= 'CODE_Monitor';
this.setController();
}//</m>CODE_Monitor



//================
this.setController = function		//<m>void<a>private<d>Controller i12n
(){
this.storeController = new CODE_storeController(this.mediator);
}//</m>setController



//================
this.setAddStoreItem = function		//<m>void<a>public<d>Add selected code to store
(){
var
/*string*/code = this.mediator.dom.getElement(this.editorId).contentWindow.getSelection().toString();
this.storeController.setAddItem(code);
}//</m>setAddStoreItem



//================
this.setRemoveStoreItem = function		//<m>void<a>public<d>Remove code from store
(){
this.storeController.setRemoveItem();
}//</m>setRemoveStoreItem



//================
this.setPasteStoreItem = function		//<m>void<a>public<d>Paste code from store
(){
var
/*string*/code = this.storeController.getItem();
if(code != '') this.setContent(code);
}//</m>setPasteStoreItem



//================
this.setRunCode = function		//<m>string<a>public<d>Evaluate code
(
code		//<p>string<d>Code to evaluate --optional
){
try{
	if(!code) code = this.controller.getContent();
	var
	/*Date*/start = new Date(),
	/*ASRDF_Parser*/parser = new ASRDF_Parser(),
	/*Object*/reader = this.mediator.getPref('code', 'loading') ? new ASRDF_FileReader(this.mediator.getCodeLastLoad(), parser) :
		new ASRDF_CodeReader(code, parser),
	/*ASRDF_Writer*/writer = new ASRDF_Writer(parser.getNamespaceSet(), parser.getDoctypeSet());
	//TEST_setOut(parser.getTripleSet());
	//writer.set_datatyping(writer.K.DATA_TYPING.OFF);
	this.mediator.setOut(writer.getOut(parser.getTripleSet()));
	var
	/*Date*/stop = new Date();
	this.execTime = stop - start;
	return '';
	}
catch(e){
	return e;
	}
}//</m>setRunCode



//================
this.getExecTime = function		//<m>string<a>public<d>Get execution time in seconds
(){
var
/*int*/time = this.execTime / 1000,
/*string*/timeString = time.toString(),
/*string[]*/numberSet = timeString.match(/(\d+).(\d+)/);
if(numberSet){
	var
	/*string*/milliseconds = numberSet[2];
	if(milliseconds.length < 3) milliseconds += '0';
	if(milliseconds.length < 3) milliseconds += '0';
	timeString = numberSet[1] + '.' + milliseconds;
	}
return timeString;
}//</m>getExecTime


this.CODE_Monitor(_mediator, _editorId);
}//</c>CODE_Monitor


//################	DEBUG
function TEST_setOut		//<f>
(
tripleSet		//<p>Object[]<d>Parser tripleSet member
){
Stdout.setOut('%N', '\n===================\ntripleSet dump\n===================');
for(var k in tripleSet){
	for(var l in tripleSet[k]){
		if(l == '<subject>'){
			for(var m in tripleSet[k][l]) Stdout.setOut('(S) %s: %N', m, tripleSet[k][l][m]);
			continue;
			}
		for(var m in tripleSet[k][l]){
			if(m == '<predicate>'){
				for(var n in tripleSet[k][l][m]) Stdout.setOut('\t(P) %s: %N', n, tripleSet[k][l][m][n]);
				continue;
				}
			for(var n in tripleSet[k][l][m]){
				if(!tripleSet[k][l][m][n]) continue;
				if(tripleSet[k][l][m][n]) Stdout.setOut('\t\t(O) %s: %N', n, tripleSet[k][l][m][n]);
				if(n == 'literal') Stdout.setOut('\t\t\t(L) %s: %N', tripleSet[k][l][m][n].type, tripleSet[k][l][m][n].lang);
				}
			Stdout.setOut('--------------%N', '');
			}
		}
	}
}//</m>setOut




