/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function CONTENT_Monitor		//<c><a>public<d>Code panel monitor class
(
_mediator,		//<p>GUI_Mediator<d>Application mediator instance
_editorId,		//<p>string<d>Editor element ID
_editorLabel	//<p>string<d>Editor target name
){
//================
this.CONTENT_Monitor = function		//<m>void<a>private<d>class constructor
(
mediator,		//<p>GUI_Mediator<d>Application mediator instance
editorId,		//<p>string<d>Editor element ID
editorLabel		//<p>string<d>Editor name
){
this.className	= 'CONTENT_Monitor';
this.mediator	= mediator;
this.editorId	= editorId;
this.editorLabel= editorLabel;
this.set_CONTENT_Monitor();
}//</m>CONTENT_Monitor



//================
this.set_CONTENT_Monitor = function		//<m>void<a>private<d>Instance i12n
(){
this.controller	= new EDITOR_Controller(this.editorId);
this.lastLoad	= null;
this.lastSave	= null;
this.setStyle();
this.set_outputHeader();
}//</m>set_CONTENT_Monitor



//================
this.setStyle = function		//<m>void<a>public<d>Set up editor style
(){
this.controller.setStyle(
	['font-family', this.mediator.getPref('font', 'name', this.editorLabel)],
	['font-size', this.mediator.getPref('font', 'size', this.editorLabel)],
	['background-color', this.mediator.getPref('color', 'bg', this.editorLabel)],
	['color', this.mediator.getPref('color', 'fg', this.editorLabel)]
	);
}//</m>setStyle



//================
this.set_outputHeader = function		//<m>void<a>public<d>Set up output header string
(){
this.outputHeader = this.mediator.getPref('output', 'header');
}//</m>set_outputHeader



//================
this.setContent = function		//<m>void<a>public<d>Set up editor content
(
content,		//<p>string<d>Editor content
replacing		//<p>boolean<d>Replacing content flag: replace || append --optional
){
this.controller.setContent(content, replacing);
}//</m>setContent



//================
this.setCommand = function		//<m>void<a>public<d>Output to output panel
(
command,		//<p>string<d>Command name
arg				//<p>string<d>Command argument --optional
){
this.controller.setCommand(command, arg);
}//</m>setCommand



//================
this.set_lastLoad = function		//<m>void<a>public<d>Set up lastLoad member
(
path				//<p>string<d>Last loading file
){
this.lastLoad = path;
}//</m>set_lastLoad



//================
this.set_lastSave = function		//<m>void<a>public<d>Set up lastSave member
(
path				//<p>string<d>Last loading file
){
this.lastSave = path;
}//</m>set_lastSave



//================
this.getContent = function		//<m>string<a>public<d>Get editor content
(){
return this.controller.getContent();
}//</m>getContent



//================
this.getOutputHeader = function		//<m>string<a>public<d>Get output header
(){
var
/*string*/header = this.outputHeader,
/*string*/customHeader = '';
try{
	var
	/*string[]*/code = header.match(this.K.HEADER_CODE_PATTERN);
	if(code) eval('customHeader=' + code[1]);
	}
catch(e){ }
header = header.replace(this.K.HEADER_CODE_PATTERN, customHeader);
header = header.replace(/\\n/, '\n');
return header + this.K.HEADER_SEPARATOR;
}//</m>getOutputHeader



//================
this.get_lastLoad = function		//<m>IO_file_fileInstantiator<a>public<d>Get lastLoad member
(){
return this.lastLoad;
}//</m>get_lastLoad



//================
this.get_lastSave = function		//<m>IO_file_fileInstantiator<a>public<d>Get lastSave member
(){
return this.lastSave;
}//</m>get_lastSave



//================
this.testClear = function		//<m>string<a>public<d>Get output header
(
content,		//<p>string<d>Editor content
replacing		//<p>boolean<d>Replacing content flag: replace || append --optional
){
return replacing && (content == '');
}//</m>testClear



this.K =
	{
	HEADER_SEPARATOR:			'\n\n',
	HEADER_CODE_PATTERN:		/`([^`]+)`/
	};



this.CONTENT_Monitor(_mediator, _editorId, _editorLabel);
}//</c>CONTENT_Monitor



